package com.hfkj.dao;

import com.hfkj.entity.BsStoreGroupDetail;
import com.hfkj.entity.BsStoreGroupDetailExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsStoreGroupDetailMapper extends BsStoreGroupDetailMapperExt {
    @SelectProvider(type=BsStoreGroupDetailSqlProvider.class, method="countByExample")
    long countByExample(BsStoreGroupDetailExample example);

    @DeleteProvider(type=BsStoreGroupDetailSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsStoreGroupDetailExample example);

    @Delete({
        "delete from bs_store_group_detail",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_store_group_detail (group_id, `name`, ",
        "product_name, product_img, ",
        "product_spec, store_product_id, ",
        "`count`, create_time, ",
        "update_time, `status`, ",
        "op_id, op_name, ext_1, ",
        "ext_2, ext_3)",
        "values (#{groupId,jdbcType=BIGINT}, #{name,jdbcType=VARCHAR}, ",
        "#{productName,jdbcType=VARCHAR}, #{productImg,jdbcType=VARCHAR}, ",
        "#{productSpec,jdbcType=VARCHAR}, #{storeProductId,jdbcType=VARCHAR}, ",
        "#{count,jdbcType=INTEGER}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsStoreGroupDetail record);

    @InsertProvider(type=BsStoreGroupDetailSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsStoreGroupDetail record);

    @SelectProvider(type=BsStoreGroupDetailSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="group_id", property="groupId", jdbcType=JdbcType.BIGINT),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_img", property="productImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_spec", property="productSpec", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_product_id", property="storeProductId", jdbcType=JdbcType.VARCHAR),
        @Result(column="count", property="count", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsStoreGroupDetail> selectByExample(BsStoreGroupDetailExample example);

    @Select({
        "select",
        "id, group_id, `name`, product_name, product_img, product_spec, store_product_id, ",
        "`count`, create_time, update_time, `status`, op_id, op_name, ext_1, ext_2, ext_3",
        "from bs_store_group_detail",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="group_id", property="groupId", jdbcType=JdbcType.BIGINT),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_img", property="productImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_spec", property="productSpec", jdbcType=JdbcType.VARCHAR),
        @Result(column="store_product_id", property="storeProductId", jdbcType=JdbcType.VARCHAR),
        @Result(column="count", property="count", jdbcType=JdbcType.INTEGER),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsStoreGroupDetail selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsStoreGroupDetailSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsStoreGroupDetail record, @Param("example") BsStoreGroupDetailExample example);

    @UpdateProvider(type=BsStoreGroupDetailSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsStoreGroupDetail record, @Param("example") BsStoreGroupDetailExample example);

    @UpdateProvider(type=BsStoreGroupDetailSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsStoreGroupDetail record);

    @Update({
        "update bs_store_group_detail",
        "set group_id = #{groupId,jdbcType=BIGINT},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "product_name = #{productName,jdbcType=VARCHAR},",
          "product_img = #{productImg,jdbcType=VARCHAR},",
          "product_spec = #{productSpec,jdbcType=VARCHAR},",
          "store_product_id = #{storeProductId,jdbcType=VARCHAR},",
          "`count` = #{count,jdbcType=INTEGER},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsStoreGroupDetail record);
}