package com.hfkj.dao;

import com.hfkj.entity.BsStoreProduct;
import com.hfkj.entity.BsStoreProductExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsStoreProductMapper extends BsStoreProductMapperExt {
    @SelectProvider(type=BsStoreProductSqlProvider.class, method="countByExample")
    long countByExample(BsStoreProductExample example);

    @DeleteProvider(type=BsStoreProductSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsStoreProductExample example);

    @Delete({
        "delete from bs_store_product",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_store_product (store_id, img, ",
        "`name`, price, sale_count, ",
        "spec, create_time, ",
        "update_time, `status`, ",
        "op_id, op_name, ext_1, ",
        "ext_2, ext_3)",
        "values (#{storeId,jdbcType=BIGINT}, #{img,jdbcType=VARCHAR}, ",
        "#{name,jdbcType=VARCHAR}, #{price,jdbcType=DECIMAL}, #{saleCount,jdbcType=INTEGER}, ",
        "#{spec,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsStoreProduct record);

    @InsertProvider(type=BsStoreProductSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsStoreProduct record);

    @SelectProvider(type=BsStoreProductSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="sale_count", property="saleCount", jdbcType=JdbcType.INTEGER),
        @Result(column="spec", property="spec", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsStoreProduct> selectByExample(BsStoreProductExample example);

    @Select({
        "select",
        "id, store_id, img, `name`, price, sale_count, spec, create_time, update_time, ",
        "`status`, op_id, op_name, ext_1, ext_2, ext_3",
        "from bs_store_product",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="store_id", property="storeId", jdbcType=JdbcType.BIGINT),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="name", property="name", jdbcType=JdbcType.VARCHAR),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="sale_count", property="saleCount", jdbcType=JdbcType.INTEGER),
        @Result(column="spec", property="spec", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsStoreProduct selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsStoreProductSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsStoreProduct record, @Param("example") BsStoreProductExample example);

    @UpdateProvider(type=BsStoreProductSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsStoreProduct record, @Param("example") BsStoreProductExample example);

    @UpdateProvider(type=BsStoreProductSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsStoreProduct record);

    @Update({
        "update bs_store_product",
        "set store_id = #{storeId,jdbcType=BIGINT},",
          "img = #{img,jdbcType=VARCHAR},",
          "`name` = #{name,jdbcType=VARCHAR},",
          "price = #{price,jdbcType=DECIMAL},",
          "sale_count = #{saleCount,jdbcType=INTEGER},",
          "spec = #{spec,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsStoreProduct record);
}