package com.hfkj.dao;

import com.hfkj.entity.BsTransferAccounts;
import com.hfkj.entity.BsTransferAccountsExample.Criteria;
import com.hfkj.entity.BsTransferAccountsExample.Criterion;
import com.hfkj.entity.BsTransferAccountsExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class BsTransferAccountsSqlProvider {

    public String countByExample(BsTransferAccountsExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("bs_transfer_accounts");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(BsTransferAccountsExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("bs_transfer_accounts");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(BsTransferAccounts record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("bs_transfer_accounts");
        
        if (record.getMerId() != null) {
            sql.VALUES("mer_id", "#{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.VALUES("mer_no", "#{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.VALUES("mer_name", "#{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAbbreviate() != null) {
            sql.VALUES("mer_abbreviate", "#{merAbbreviate,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.VALUES("order_no", "#{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOrderNo() != null) {
            sql.VALUES("platform_order_no", "#{platformOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverPlatformType() != null) {
            sql.VALUES("receiver_platform_type", "#{receiverPlatformType,jdbcType=INTEGER}");
        }
        
        if (record.getReceiverPlatformNo() != null) {
            sql.VALUES("receiver_platform_no", "#{receiverPlatformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAmount() != null) {
            sql.VALUES("amount", "#{amount,jdbcType=DECIMAL}");
        }
        
        if (record.getShdFeeAmt() != null) {
            sql.VALUES("shd_fee_amt", "#{shdFeeAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleDate() != null) {
            sql.VALUES("settle_date", "#{settleDate,jdbcType=DATE}");
        }
        
        if (record.getContent() != null) {
            sql.VALUES("content", "#{content,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getTransferTime() != null) {
            sql.VALUES("transfer_time", "#{transferTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateType() != null) {
            sql.VALUES("create_type", "#{createType,jdbcType=INTEGER}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRebateTransferCycleIdentifier() != null) {
            sql.VALUES("rebate_transfer_cycle_identifier", "#{rebateTransferCycleIdentifier,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(BsTransferAccountsExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("mer_id");
        sql.SELECT("mer_no");
        sql.SELECT("mer_name");
        sql.SELECT("mer_abbreviate");
        sql.SELECT("order_no");
        sql.SELECT("platform_order_no");
        sql.SELECT("receiver_platform_type");
        sql.SELECT("receiver_platform_no");
        sql.SELECT("amount");
        sql.SELECT("shd_fee_amt");
        sql.SELECT("settle_date");
        sql.SELECT("content");
        sql.SELECT("`status`");
        sql.SELECT("transfer_time");
        sql.SELECT("create_time");
        sql.SELECT("create_type");
        sql.SELECT("update_time");
        sql.SELECT("rebate_transfer_cycle_identifier");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("bs_transfer_accounts");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        BsTransferAccounts record = (BsTransferAccounts) parameter.get("record");
        BsTransferAccountsExample example = (BsTransferAccountsExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("bs_transfer_accounts");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAbbreviate() != null) {
            sql.SET("mer_abbreviate = #{record.merAbbreviate,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOrderNo() != null) {
            sql.SET("platform_order_no = #{record.platformOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverPlatformType() != null) {
            sql.SET("receiver_platform_type = #{record.receiverPlatformType,jdbcType=INTEGER}");
        }
        
        if (record.getReceiverPlatformNo() != null) {
            sql.SET("receiver_platform_no = #{record.receiverPlatformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAmount() != null) {
            sql.SET("amount = #{record.amount,jdbcType=DECIMAL}");
        }
        
        if (record.getShdFeeAmt() != null) {
            sql.SET("shd_fee_amt = #{record.shdFeeAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleDate() != null) {
            sql.SET("settle_date = #{record.settleDate,jdbcType=DATE}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{record.content,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getTransferTime() != null) {
            sql.SET("transfer_time = #{record.transferTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateType() != null) {
            sql.SET("create_type = #{record.createType,jdbcType=INTEGER}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRebateTransferCycleIdentifier() != null) {
            sql.SET("rebate_transfer_cycle_identifier = #{record.rebateTransferCycleIdentifier,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("bs_transfer_accounts");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("mer_id = #{record.merId,jdbcType=BIGINT}");
        sql.SET("mer_no = #{record.merNo,jdbcType=VARCHAR}");
        sql.SET("mer_name = #{record.merName,jdbcType=VARCHAR}");
        sql.SET("mer_abbreviate = #{record.merAbbreviate,jdbcType=VARCHAR}");
        sql.SET("order_no = #{record.orderNo,jdbcType=VARCHAR}");
        sql.SET("platform_order_no = #{record.platformOrderNo,jdbcType=VARCHAR}");
        sql.SET("receiver_platform_type = #{record.receiverPlatformType,jdbcType=INTEGER}");
        sql.SET("receiver_platform_no = #{record.receiverPlatformNo,jdbcType=VARCHAR}");
        sql.SET("amount = #{record.amount,jdbcType=DECIMAL}");
        sql.SET("shd_fee_amt = #{record.shdFeeAmt,jdbcType=DECIMAL}");
        sql.SET("settle_date = #{record.settleDate,jdbcType=DATE}");
        sql.SET("content = #{record.content,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("transfer_time = #{record.transferTime,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("create_type = #{record.createType,jdbcType=INTEGER}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("rebate_transfer_cycle_identifier = #{record.rebateTransferCycleIdentifier,jdbcType=BIGINT}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        BsTransferAccountsExample example = (BsTransferAccountsExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(BsTransferAccounts record) {
        SQL sql = new SQL();
        sql.UPDATE("bs_transfer_accounts");
        
        if (record.getMerId() != null) {
            sql.SET("mer_id = #{merId,jdbcType=BIGINT}");
        }
        
        if (record.getMerNo() != null) {
            sql.SET("mer_no = #{merNo,jdbcType=VARCHAR}");
        }
        
        if (record.getMerName() != null) {
            sql.SET("mer_name = #{merName,jdbcType=VARCHAR}");
        }
        
        if (record.getMerAbbreviate() != null) {
            sql.SET("mer_abbreviate = #{merAbbreviate,jdbcType=VARCHAR}");
        }
        
        if (record.getOrderNo() != null) {
            sql.SET("order_no = #{orderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPlatformOrderNo() != null) {
            sql.SET("platform_order_no = #{platformOrderNo,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiverPlatformType() != null) {
            sql.SET("receiver_platform_type = #{receiverPlatformType,jdbcType=INTEGER}");
        }
        
        if (record.getReceiverPlatformNo() != null) {
            sql.SET("receiver_platform_no = #{receiverPlatformNo,jdbcType=VARCHAR}");
        }
        
        if (record.getAmount() != null) {
            sql.SET("amount = #{amount,jdbcType=DECIMAL}");
        }
        
        if (record.getShdFeeAmt() != null) {
            sql.SET("shd_fee_amt = #{shdFeeAmt,jdbcType=DECIMAL}");
        }
        
        if (record.getSettleDate() != null) {
            sql.SET("settle_date = #{settleDate,jdbcType=DATE}");
        }
        
        if (record.getContent() != null) {
            sql.SET("content = #{content,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getTransferTime() != null) {
            sql.SET("transfer_time = #{transferTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateType() != null) {
            sql.SET("create_type = #{createType,jdbcType=INTEGER}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getRebateTransferCycleIdentifier() != null) {
            sql.SET("rebate_transfer_cycle_identifier = #{rebateTransferCycleIdentifier,jdbcType=BIGINT}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, BsTransferAccountsExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}