package com.hfkj.group;

import com.hfkj.entity.BsStoreExtMsg;
import com.hfkj.entity.BsStoreImg;
import com.hfkj.entity.BsStoreProduct;
import org.bouncycastle.crypto.tls.MACAlgorithm;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // 团购业务
 * @createTime 14:37 2023/10/23
 **/
public interface BsStoreGroupService {


    /**
    * @Author Sum1Dream
    * @Name insertStoreImg
    * @Description // 新增门店图片
    * @Date 16:31 2023/10/23
    * @Param bsStoreImg
     * @return void
    */
    void insertStoreImg(BsStoreImg bsStoreImg);

    /**
    * @Author Sum1Dream
    * @Name editStoreImg
    * @Description // 编辑门店图片
    * @Date 16:31 2023/10/23 
    * @Param bsStoreImg  
     * @return void
    */
    void editStoreImg(BsStoreImg bsStoreImg);

    /**
    * @Author Sum1Dream
    * @Name findStoreImg
    * @Description // 根据id查询门店图片
    * @Date 16:31 2023/10/23 
    * @Param id  
     * @return com.hfkj.entity.BsStoreImg
    */
    BsStoreImg findStoreImg(Long id);

    BsStoreImg findStoreImgByStoreId(Long storeId);

    /**
    * @Author Sum1Dream
    * @Name getBsStoreByList
    * @Description // 查询门店图片列表
    * @Date 16:32 2023/10/23
    * @Param map
     * @return java.util.List<com.hfkj.entity.BsStoreImg>
    */
    List<BsStoreImg> getBsStoreImgByList(Map<String , Object> map);

    /**
    * @Author Sum1Dream
    * @Name insertStoreProduct
    * @Description // 新增门店产品
    * @Date 17:28 2023/10/23
    * @Param bsStoreProduct
     * @return void
    */
    void insertStoreProduct(BsStoreProduct bsStoreProduct);

    /**
     * @Author Sum1Dream
     * @Name editStoreProduct
     * @Description //修改门店产品
     * @Date 17:28 2023/10/23
     * @Param bsStoreProduct
     * @return void
     */
    void editStoreProduct(BsStoreProduct bsStoreProduct);

    /**
     * @Author Sum1Dream
     * @Name findStoreProduct
     * @Description //根据id查询门店产品
     * @Date 17:28 2023/10/23
     * @Param bsStoreProduct
     * @return void
     */
    BsStoreProduct findStoreProduct(Long id);

    /**
     * @Author Sum1Dream
     * @Name getStoreProductByList
     * @Description // 查询门店产品列表
     * @Date 17:28 2023/10/23
     * @Param bsStoreProduct
     * @return void
     */
    List<BsStoreProduct> getStoreProductByList(Map<String , Object> map);


    /**
    * @Author Sum1Dream
    * @Name insertStoreExtMsg
    * @Description // 新增门店扩展信息
    * @Date 9:33 2023/11/1
    * @Param bsStoreExtMsg
     * @return void
    */
    void insertStoreExtMsg(BsStoreExtMsg bsStoreExtMsg);


    /**
    * @Author Sum1Dream
    * @Name editStoreExtMsg
    * @Description // 编辑门店扩展信息
    * @Date 9:33 2023/11/1
    * @Param bsStoreExtMsg
     * @return void
    */
    void editStoreExtMsg(BsStoreExtMsg bsStoreExtMsg);

    /**
    * @Author Sum1Dream
    * @Name findStoreExtMsg
    * @Description // 根据id查询门店扩展信息内容
    * @Date 9:34 2023/11/1
    * @Param id
     * @return com.hfkj.entity.BsStoreExtMsg
    */
    BsStoreExtMsg findStoreExtMsg(Long id);

    /**
    * @Author Sum1Dream
    * @Name findStoreExtMsgByStoreId
    * @Description // 根据门店Id查询门店扩展信息内容
    * @Date 9:36 2023/11/1
    * @Param storeId
     * @return com.hfkj.entity.BsStoreExtMsg
    */
    BsStoreExtMsg findStoreExtMsgByStoreId(Long storeId);

    /**
    * @Author Sum1Dream
    * @Name getStoreExtMsgByList
    * @Description // 查询列表
    * @Date 9:34 2023/11/1
    * @Param map
     * @return java.util.List<com.hfkj.entity.BsStoreExtMsg>
    */
    List<BsStoreExtMsg> getStoreExtMsgByList(Map<String , Object> map);


}
