package com.hfkj.model;

import ch.qos.logback.core.db.dialect.DBUtil;
import com.hfkj.entity.BsStoreGroupContent;

import javax.xml.crypto.Data;
import java.util.List;

/**
 * 对外的门店信息内容
 * @author sum1dream
 */
@lombok.Data
public class OpenStoreModel {

    // 门店地址
    private String address;

    // 门店Id
    private String storeId;

    // 门头照
    private String doorHeadImg;

    // 门店名称
    private String storeName;

    // 父类行业分类id
    private Long parentId;

    // 子类行业分类id
    private Long childId;

    // 父类行业分类名称
    private String parentName;

    // 子类行业分类名称
    private String childName;

    // 门店状态 0：删除  1：正常  2：停用   3：审核中   4：审核失败
    private Integer storeStatus;

    // 唯独
    private String latitude;

    // 经度
    private String longitude;

    // 创建时间
    private Data storeCreateTime;

    private Double distance;

    private String distances;


    private List<BsStoreGroupContent> storeGroupContentList;

}
