package com.hfkj.openapi.v1.model.request;

import lombok.Data;
import org.hibernate.validator.constraints.Length;

import javax.validation.constraints.DecimalMax;
import javax.validation.constraints.DecimalMin;
import javax.validation.constraints.NotBlank;
import java.math.BigDecimal;

/**
 * 请求查询转账结果模型
 * @className: RequestTransferAccountsModel
 * @author: HuRui
 * @date: 2023/10/23
 **/
@Data
public class RequestQueryTransferInfoModel {

    /**
     * 商户号
     */
    @NotBlank(message = "商户号必填项")
    private String merchantNo;

    /**
     * 订单号
     */
    @NotBlank(message = "订单号必填项")
    private String orderNo;

    /**
     * 签名参数
     */
    @NotBlank(message = "签名必填项")
    private String sign;

}
